Index: /NEMO/branches/2020/dev_r12377_KERNEL-06_techene_e3/src/OCE/DOM/domqe.F90
===================================================================
--- /NEMO/branches/2020/dev_r12377_KERNEL-06_techene_e3/src/OCE/DOM/domqe.F90	(revision 12679)
+++ /NEMO/branches/2020/dev_r12377_KERNEL-06_techene_e3/src/OCE/DOM/domqe.F90	(revision 12680)
@@ -9,31 +9,31 @@
    !!            3.6  !  2014-11  (P. Mathiot) add ice shelf capability
    !!            4.1  !  2019-08  (A. Coward, D. Storkey) rename dom_vvl_sf_swp -> dom_vvl_sf_update for new timestepping
-   !!            4.x  ! 2020-02  (G. Madec, S. Techene) pure z* (quasi-eulerian) coordinate
+   !!            4.x  !  2020-02  (G. Madec, S. Techene) pure z* (quasi-eulerian) coordinate
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
-   !!   dom_qe_init     : define initial vertical scale factors, depths and column thickness
-   !!   dom_qe_sf_nxt   : Compute next vertical scale factors
-   !!   dom_qe_sf_update   : Swap vertical scale factors and update the vertical grid
+   !!   dom_qe_init   : define initial vertical scale factors, depths and column thickness
+   !!   dom_qe_sf_nxt : Compute next vertical scale factors
+   !!   dom_qe_sf_update: Swap vertical scale factors and update the vertical grid
    !!   dom_qe_interpol : Interpolate vertical scale factors from one grid point to another
-   !!   dom_qe_r3c      : Compute ssh/h_0 ratioat t-, u-, v-, and optionally f-points
-   !!   dom_qe_rst      : read/write restart file
-   !!   dom_qe_ctl      : Check the vvl options
+   !!   dom_qe_r3c    : Compute ssh/h_0 ratioat t-, u-, v-, and optionally f-points
+   !!       qe_rst_read : read/write restart file
+   !!   dom_qe_ctl    : Check the vvl options
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers
-   USE phycst          ! physical constant
-   USE dom_oce         ! ocean space and time domain
+   USE oce            ! ocean dynamics and tracers
+   USE phycst         ! physical constant
+   USE dom_oce        ! ocean space and time domain
    USE dynadv  , ONLY : ln_dynadv_vec
-   USE isf_oce         ! iceshelf cavities
-   USE sbc_oce         ! ocean surface boundary condition
-   USE wet_dry         ! wetting and drying
-   USE usrdef_istate   ! user defined initial state (wad only)
-   USE restart         ! ocean restart
+   USE isf_oce        ! iceshelf cavities
+   USE sbc_oce        ! ocean surface boundary condition
+   USE wet_dry        ! wetting and drying
+   USE usrdef_istate  ! user defined initial state (wad only)
+   USE restart        ! ocean restart
    !
-   USE in_out_manager  ! I/O manager
-   USE iom             ! I/O manager library
-   USE lib_mpp         ! distributed memory computing library
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE timing          ! Timing
+   USE in_out_manager ! I/O manager
+   USE iom            ! I/O manager library
+   USE lib_mpp        ! distributed memory computing library
+   USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
+   USE timing         ! Timing
 
    IMPLICIT NONE
@@ -42,7 +42,8 @@
    PUBLIC  dom_qe_init       ! called by domain.F90
    PUBLIC  dom_qe_zgr        ! called by isfcpl.F90
-   PUBLIC  dom_qe_sf_nxt     ! called by steplf.F90
-   PUBLIC  dom_qe_sf_update  ! called by steplf.F90
+!!st   PUBLIC  dom_qe_sf_nxt     ! called by steplf.F90
+!!st   PUBLIC  dom_qe_sf_update  ! called by steplf.F90
    PUBLIC  dom_h_nxt         ! called by steplf.F90
+   PUBLIC  dom_h_update      ! called by steplf.F90
    PUBLIC  dom_qe_r3c        ! called by steplf.F90
 
@@ -102,13 +103,13 @@
       !
       !                    ! Read or initialize e3t_(b/n), tilde_e3t_(b/n) and hdiv_lf
-      CALL dom_qe_rst( nit000, Kbb, Kmm, 'READ' )
-      e3t(:,:,jpk,Kaa) = e3t_0(:,:,jpk)  ! last level always inside the sea floor set one for all
+      CALL qe_rst_read( nit000, Kbb, Kmm )
+!!st      e3t(:,:,jpk,Kaa) = e3t_0(:,:,jpk)  ! last level always inside the sea floor set one for all
       !
       CALL dom_qe_zgr(Kbb, Kmm, Kaa) ! interpolation scale factor, depth and water column
       !
-      IF(lwxios) THEN   ! define variables in restart file when writing with XIOS
-         CALL iom_set_rstw_var_active('e3t_b')
-         CALL iom_set_rstw_var_active('e3t_n')
-      ENDIF
+      ! IF(lwxios) THEN   ! define variables in restart file when writing with XIOS
+      !    CALL iom_set_rstw_var_active('e3t_b')
+      !    CALL iom_set_rstw_var_active('e3t_n')
+      ! ENDIF
       !
    END SUBROUTINE dom_qe_init
@@ -147,28 +148,30 @@
       CALL dom_qe_r3c( ssh(:,:,Kmm), r3t(:,:,Kmm), r3u(:,:,Kmm), r3v(:,:,Kmm), r3f(:,:) )
       !
-      DO jk = 1, jpkm1                    ! Horizontal interpolation of e3t
-         e3t(:,:,jk,Kbb) = e3t_0(:,:,jk) * ( 1._wp + r3t(:,:,Kbb) * tmask(:,:,jk) )   ! Kbb time level
-         e3u(:,:,jk,Kbb) = e3u_0(:,:,jk) * ( 1._wp + r3u(:,:,Kbb) * umask(:,:,jk) )
-         e3v(:,:,jk,Kbb) = e3v_0(:,:,jk) * ( 1._wp + r3v(:,:,Kbb) * vmask(:,:,jk) )
-         e3t(:,:,jk,Kmm) = e3t_0(:,:,jk) * ( 1._wp + r3t(:,:,Kmm) * tmask(:,:,jk) )   ! Kmm time level
-         e3u(:,:,jk,Kmm) = e3u_0(:,:,jk) * ( 1._wp + r3u(:,:,Kmm) * umask(:,:,jk) )
-         e3v(:,:,jk,Kmm) = e3v_0(:,:,jk) * ( 1._wp + r3v(:,:,Kmm) * vmask(:,:,jk) )
-         e3f(:,:,jk)     = e3f_0(:,:,jk) * ( 1._wp + r3f(:,:)     * fmask(:,:,jk) )
-      END DO
-      !
-      DO jk = 1, jpk                      ! Vertical interpolation of e3t,u,v
-         !                                   ! The ratio does not have to be masked at w-level
-         e3w (:,:,jk,Kbb) =  e3w_0(:,:,jk) * ( 1._wp + r3t(:,:,Kbb) )   ! Kbb time level
-         e3uw(:,:,jk,Kbb) = e3uw_0(:,:,jk) * ( 1._wp + r3u(:,:,Kbb) )
-         e3vw(:,:,jk,Kbb) = e3vw_0(:,:,jk) * ( 1._wp + r3v(:,:,Kbb) )
-         e3w (:,:,jk,Kmm) =  e3w_0(:,:,jk) * ( 1._wp + r3t(:,:,Kmm) )   ! Kmm time level
-         e3uw(:,:,jk,Kmm) = e3uw_0(:,:,jk) * ( 1._wp + r3u(:,:,Kmm) )
-         e3vw(:,:,jk,Kmm) = e3vw_0(:,:,jk) * ( 1._wp + r3v(:,:,Kmm) )
-      END DO
-      !
-      ! We need to define e3[tuv]_a for AGRIF initialisation (should not be a problem for the restartability...)
-      e3t(:,:,:,Kaa) = e3t(:,:,:,Kmm)
-      e3u(:,:,:,Kaa) = e3u(:,:,:,Kmm)
-      e3v(:,:,:,Kaa) = e3v(:,:,:,Kmm)
+! !!st
+!       DO jk = 1, jpkm1                    ! Horizontal interpolation of e3t
+!          e3t(:,:,jk,Kbb) = e3t_0(:,:,jk) * ( 1._wp + r3t(:,:,Kbb) * tmask(:,:,jk) )   ! Kbb time level
+!          e3u(:,:,jk,Kbb) = e3u_0(:,:,jk) * ( 1._wp + r3u(:,:,Kbb) * umask(:,:,jk) )
+!          e3v(:,:,jk,Kbb) = e3v_0(:,:,jk) * ( 1._wp + r3v(:,:,Kbb) * vmask(:,:,jk) )
+!          e3t(:,:,jk,Kmm) = e3t_0(:,:,jk) * ( 1._wp + r3t(:,:,Kmm) * tmask(:,:,jk) )   ! Kmm time level
+!          e3u(:,:,jk,Kmm) = e3u_0(:,:,jk) * ( 1._wp + r3u(:,:,Kmm) * umask(:,:,jk) )
+!          e3v(:,:,jk,Kmm) = e3v_0(:,:,jk) * ( 1._wp + r3v(:,:,Kmm) * vmask(:,:,jk) )
+!          e3f(:,:,jk)     = e3f_0(:,:,jk) * ( 1._wp + r3f(:,:)     * fmask(:,:,jk) )
+!       END DO
+!       !
+!       DO jk = 1, jpk                      ! Vertical interpolation of e3t,u,v
+!          !                                   ! The ratio does not have to be masked at w-level
+!          e3w (:,:,jk,Kbb) =  e3w_0(:,:,jk) * ( 1._wp + r3t(:,:,Kbb) )   ! Kbb time level
+!          e3uw(:,:,jk,Kbb) = e3uw_0(:,:,jk) * ( 1._wp + r3u(:,:,Kbb) )
+!          e3vw(:,:,jk,Kbb) = e3vw_0(:,:,jk) * ( 1._wp + r3v(:,:,Kbb) )
+!          e3w (:,:,jk,Kmm) =  e3w_0(:,:,jk) * ( 1._wp + r3t(:,:,Kmm) )   ! Kmm time level
+!          e3uw(:,:,jk,Kmm) = e3uw_0(:,:,jk) * ( 1._wp + r3u(:,:,Kmm) )
+!          e3vw(:,:,jk,Kmm) = e3vw_0(:,:,jk) * ( 1._wp + r3v(:,:,Kmm) )
+!       END DO
+!       !
+!       ! We need to define e3[tuv]_a for AGRIF initialisation (should not be a problem for the restartability...)
+!       e3t(:,:,:,Kaa) = e3t(:,:,:,Kmm)
+!       e3u(:,:,:,Kaa) = e3u(:,:,:,Kmm)
+!       e3v(:,:,:,Kaa) = e3v(:,:,:,Kmm)
+!!st end
       !
       !                    !==  depth of t and w-point  ==!   (set the isf depth as it is in the initial timestep)
@@ -221,20 +224,86 @@
    END SUBROUTINE dom_qe_zgr
 
-
-   SUBROUTINE dom_qe_sf_nxt( kt, Kbb, Kmm, Kaa, kcall )
+! !!st
+!    SUBROUTINE dom_qe_sf_nxt( kt, Kbb, Kmm, Kaa, kcall )
+!       !!----------------------------------------------------------------------
+!       !!                ***  ROUTINE dom_qe_sf_nxt  ***
+!       !!
+!       !! ** Purpose :  - compute the after scale factors used in tra_zdf, dynnxt,
+!       !!                 tranxt and dynspg routines
+!       !!
+!       !! ** Method  :  - z_star case:  Repartition of ssh INCREMENT proportionnaly to the level thickness.
+!       !!
+!       !! ** Action  :  - hdiv_lf    : restoring towards full baroclinic divergence in z_tilde case
+!       !!               - tilde_e3t_a: after increment of vertical scale factor
+!       !!                              in z_tilde case
+!       !!               - e3(t/u/v)_a
+!       !!
+!       !! Reference  : Leclair, M., and Madec, G. 2011, Ocean Modelling.
+!       !!----------------------------------------------------------------------
+!       INTEGER, INTENT( in )           ::   kt             ! time step
+!       INTEGER, INTENT( in )           ::   Kbb, Kmm, Kaa  ! time step
+!       INTEGER, INTENT( in ), OPTIONAL ::   kcall          ! optional argument indicating call sequence
+!       !
+!       INTEGER                ::   ji, jj, jk            ! dummy loop indices
+!       INTEGER , DIMENSION(3) ::   ijk_max, ijk_min      ! temporary integers
+!       REAL(wp)               ::   z2dt, z_tmin, z_tmax  ! local scalars
+!       LOGICAL                ::   ll_do_bclinic         ! local logical
+!       REAL(wp), DIMENSION(jpi,jpj)     ::   zht, z_scale, zwu, zwv, zhdiv
+!       !!----------------------------------------------------------------------
+!       !
+!       IF( ln_linssh )   RETURN      ! No calculation in linear free surface
+!       !
+!       IF( ln_timing )   CALL timing_start('dom_qe_sf_nxt')
+!       !
+!       IF( kt == nit000 ) THEN
+!          IF(lwp) WRITE(numout,*)
+!          IF(lwp) WRITE(numout,*) 'dom_qe_sf_nxt : compute after scale factors'
+!          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~'
+!       ENDIF
+!
+!
+!       ! ******************************* !
+!       ! After acale factors at t-points !
+!       ! ******************************* !
+!       !                                                ! --------------------------------------------- !
+!       !                                                ! z_star coordinate and barotropic z-tilde part !
+!       !                                                ! --------------------------------------------- !
+!       !
+!       !
+!       ! *********************************** !
+!       ! After scale factors at u- v- points !
+!       ! *********************************** !
+!       !
+!       DO jk = 1, jpkm1
+!          e3t(:,:,jk,Kaa) = e3t_0(:,:,jk) * ( 1._wp + r3t(:,:,Kaa) * tmask(:,:,jk) )
+!          e3u(:,:,jk,Kaa) = e3u_0(:,:,jk) * ( 1._wp + r3u(:,:,Kaa) * umask(:,:,jk) )
+!          e3v(:,:,jk,Kaa) = e3v_0(:,:,jk) * ( 1._wp + r3v(:,:,Kaa) * vmask(:,:,jk) )
+!       END DO
+!       !
+!       ! *********************************** !
+!       ! After depths at u- v points         !
+!       ! *********************************** !
+!       hu(:,:,Kaa) = hu_0(:,:) * ( 1._wp + r3u(:,:,Kaa) )
+!       hv(:,:,Kaa) = hv_0(:,:) * ( 1._wp + r3v(:,:,Kaa) )
+!       !                                        ! Inverse of the local depth
+!       r1_hu(:,:,Kaa) = ssumask(:,:) / ( hu(:,:,Kaa) + 1._wp - ssumask(:,:) )
+!       r1_hv(:,:,Kaa) = ssvmask(:,:) / ( hv(:,:,Kaa) + 1._wp - ssvmask(:,:) )
+!       !
+!       IF( ln_timing )   CALL timing_stop('dom_qe_sf_nxt')
+!       !
+!    END SUBROUTINE dom_qe_sf_nxt
+!!st end
+
+   SUBROUTINE dom_h_nxt( kt, Kbb, Kmm, Kaa, kcall )
       !!----------------------------------------------------------------------
       !!                ***  ROUTINE dom_qe_sf_nxt  ***
       !!
-      !! ** Purpose :  - compute the after scale factors used in tra_zdf, dynnxt,
+      !! ** Purpose :  - compute the after water heigh used in tra_zdf, dynnxt,
       !!                 tranxt and dynspg routines
       !!
-      !! ** Method  :  - z_star case:  Repartition of ssh INCREMENT proportionnaly to the level thickness.
-      !!
-      !! ** Action  :  - hdiv_lf    : restoring towards full baroclinic divergence in z_tilde case
-      !!               - tilde_e3t_a: after increment of vertical scale factor
-      !!                              in z_tilde case
-      !!               - e3(t/u/v)_a
-      !!
-      !! Reference  : Leclair, M., and Madec, G. 2011, Ocean Modelling.
+      !! ** Method  :  - z_star case:  Proportionnaly to the water column thickness.
+      !!
+      !! ** Action  :  - h(u/v) update wrt ssh/h(u/v)_0
+      !!
       !!----------------------------------------------------------------------
       INTEGER, INTENT( in )           ::   kt             ! time step
@@ -242,39 +311,15 @@
       INTEGER, INTENT( in ), OPTIONAL ::   kcall          ! optional argument indicating call sequence
       !
-      INTEGER                ::   ji, jj, jk            ! dummy loop indices
-      INTEGER , DIMENSION(3) ::   ijk_max, ijk_min      ! temporary integers
-      REAL(wp)               ::   z2dt, z_tmin, z_tmax  ! local scalars
-      LOGICAL                ::   ll_do_bclinic         ! local logical
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zht, z_scale, zwu, zwv, zhdiv
       !!----------------------------------------------------------------------
       !
       IF( ln_linssh )   RETURN      ! No calculation in linear free surface
       !
-      IF( ln_timing )   CALL timing_start('dom_qe_sf_nxt')
+      IF( ln_timing )   CALL timing_start('dom_h_nxt')
       !
       IF( kt == nit000 ) THEN
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dom_qe_sf_nxt : compute after scale factors'
+         IF(lwp) WRITE(numout,*) 'dom_h_nxt : compute after scale factors'
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~'
       ENDIF
-
-
-      ! ******************************* !
-      ! After acale factors at t-points !
-      ! ******************************* !
-      !                                                ! --------------------------------------------- !
-      !                                                ! z_star coordinate and barotropic z-tilde part !
-      !                                                ! --------------------------------------------- !
-      !
-      !
-      ! *********************************** !
-      ! After scale factors at u- v- points !
-      ! *********************************** !
-      !
-      DO jk = 1, jpkm1
-         e3t(:,:,jk,Kaa) = e3t_0(:,:,jk) * ( 1._wp + r3t(:,:,Kaa) * tmask(:,:,jk) )
-         e3u(:,:,jk,Kaa) = e3u_0(:,:,jk) * ( 1._wp + r3u(:,:,Kaa) * umask(:,:,jk) )
-         e3v(:,:,jk,Kaa) = e3v_0(:,:,jk) * ( 1._wp + r3v(:,:,Kaa) * vmask(:,:,jk) )
-      END DO
       !
       ! *********************************** !
@@ -287,52 +332,118 @@
       r1_hv(:,:,Kaa) = ssvmask(:,:) / ( hv(:,:,Kaa) + 1._wp - ssvmask(:,:) )
       !
-      IF( ln_timing )   CALL timing_stop('dom_qe_sf_nxt')
-      !
-   END SUBROUTINE dom_qe_sf_nxt
-
-
-   SUBROUTINE dom_h_nxt( kt, Kbb, Kmm, Kaa, kcall )
-      !!----------------------------------------------------------------------
-      !!                ***  ROUTINE dom_qe_sf_nxt  ***
-      !!
-      !! ** Purpose :  - compute the after water heigh used in tra_zdf, dynnxt,
-      !!                 tranxt and dynspg routines
-      !!
-      !! ** Method  :  - z_star case:  Proportionnaly to the water column thickness.
-      !!
-      !! ** Action  :  - h(u/v) update wrt ssh/h(u/v)_0
-      !!
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT( in )           ::   kt             ! time step
-      INTEGER, INTENT( in )           ::   Kbb, Kmm, Kaa  ! time step
-      INTEGER, INTENT( in ), OPTIONAL ::   kcall          ! optional argument indicating call sequence
-      !
-      !!----------------------------------------------------------------------
-      !
-      IF( ln_linssh )   RETURN      ! No calculation in linear free surface
-      !
-      IF( ln_timing )   CALL timing_start('dom_h_nxt')
-      !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dom_h_nxt : compute after scale factors'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~'
-      ENDIF
-      !
-      ! *********************************** !
-      ! After depths at u- v points         !
-      ! *********************************** !
-      hu(:,:,Kaa) = hu_0(:,:) * ( 1._wp + r3u(:,:,Kaa) )
-      hv(:,:,Kaa) = hv_0(:,:) * ( 1._wp + r3v(:,:,Kaa) )
-      !                                        ! Inverse of the local depth
-      r1_hu(:,:,Kaa) = ssumask(:,:) / ( hu(:,:,Kaa) + 1._wp - ssumask(:,:) )
-      r1_hv(:,:,Kaa) = ssvmask(:,:) / ( hv(:,:,Kaa) + 1._wp - ssvmask(:,:) )
-      !
       IF( ln_timing )   CALL timing_stop('dom_h_nxt')
       !
    END SUBROUTINE dom_h_nxt
 
-
-   SUBROUTINE dom_qe_sf_update( kt, Kbb, Kmm, Kaa )
+! !!st
+!    SUBROUTINE dom_qe_sf_update( kt, Kbb, Kmm, Kaa )
+!       !!----------------------------------------------------------------------
+!       !!                ***  ROUTINE dom_qe_sf_update  ***
+!       !!
+!       !! ** Purpose :  for z tilde case: compute time filter and swap of scale factors
+!       !!               compute all depths and related variables for next time step
+!       !!               write outputs and restart file
+!       !!
+!       !! ** Method  :  - reconstruct scale factor at other grid points (interpolate)
+!       !!               - recompute depths and water height fields
+!       !!
+!       !! ** Action  :  - Recompute:
+!       !!                    e3(u/v)_b
+!       !!                    e3w(:,:,:,Kmm)
+!       !!                    e3(u/v)w_b
+!       !!                    e3(u/v)w_n
+!       !!                    gdept(:,:,:,Kmm), gdepw(:,:,:,Kmm)  and gde3w
+!       !!                    h(u/v) and h(u/v)r
+!       !!
+!       !! Reference  : Leclair, M., and G. Madec, 2009, Ocean Modelling.
+!       !!              Leclair, M., and G. Madec, 2011, Ocean Modelling.
+!       !!----------------------------------------------------------------------
+!       INTEGER, INTENT( in ) ::   kt              ! time step
+!       INTEGER, INTENT( in ) ::   Kbb, Kmm, Kaa   ! time level indices
+!       !
+!       INTEGER  ::   ji, jj, jk   ! dummy loop indices
+!       REAL(wp) ::   zcoef        ! local scalar
+!       !!----------------------------------------------------------------------
+!       !
+!       IF( ln_linssh )   RETURN      ! No calculation in linear free surface
+!       !
+!       IF( ln_timing )   CALL timing_start('dom_qe_sf_update')
+!       !
+!       IF( kt == nit000 )   THEN
+!          IF(lwp) WRITE(numout,*)
+!          IF(lwp) WRITE(numout,*) 'dom_qe_sf_update : - interpolate scale factors and compute depths for next time step'
+!          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~~~'
+!       ENDIF
+!       !
+!       ! Compute all missing vertical scale factor and depths
+!       ! ====================================================
+!       ! Horizontal scale factor interpolations
+!       ! --------------------------------------
+!       ! - ML - e3u(:,:,:,Kbb) and e3v(:,:,:,Kbb) are already computed in dynnxt
+!       ! - JC - hu(:,:,:,Kbb), hv(:,:,:,:,Kbb), hur_b, hvr_b also
+!
+!
+!       ! Scale factor computation
+!       DO jk = 1, jpk             ! Horizontal interpolation
+!          e3f(:,:,jk)      =  e3f_0(:,:,jk) * ( 1._wp + r3f(:,:) * fmask(:,:,jk) )   ! Kmm time level
+!          !                       ! Vertical interpolation
+! 	      !                                   ! The ratio does not have to be masked at w-level
+!          e3w (:,:,jk,Kmm) =  e3w_0(:,:,jk) * ( 1._wp + r3t(:,:,Kmm) )   ! Kmm time level
+!          e3uw(:,:,jk,Kmm) = e3uw_0(:,:,jk) * ( 1._wp + r3u(:,:,Kmm) )
+!          e3vw(:,:,jk,Kmm) = e3vw_0(:,:,jk) * ( 1._wp + r3v(:,:,Kmm) )
+!          e3w (:,:,jk,Kbb) =  e3w_0(:,:,jk) * ( 1._wp + r3t(:,:,Kbb) )   ! Kbb time level
+!          e3uw(:,:,jk,Kbb) = e3uw_0(:,:,jk) * ( 1._wp + r3u(:,:,Kbb) )
+!          e3vw(:,:,jk,Kbb) = e3vw_0(:,:,jk) * ( 1._wp + r3v(:,:,Kbb) )
+!       END DO
+!
+!
+!       IF( ln_isf ) THEN          !** IceShelF cavities
+!       !                             ! to be created depending of the new names in isf
+!       !                             ! it should be something like that :  (with h_isf = thickness of iceshelf)
+!       !                             !  in fact currently, h_isf(:,:) is called : risfdep(:,:)
+! !!gm - depth idea 0  : just realize that mask is not needed ===>>>> with ISF, rescale all grid point position below ISF : no mask !
+!          gdept(:,:,1,Kmm) = gdept_0(:,:,1) * ( 1._wp + r3t(:,:,Kmm) )
+!          gdepw(:,:,1,Kmm) = 0._wp                            ! Initialized to zero one for all
+!          gde3w(:,:,1)     = gdept(:,:,1,Kmm) - ssh(:,:,Kmm)  ! reference to a common level z=0 for hpg
+!          DO jk = 2, jpk
+!             gdept(:,:,jk,Kmm) = MIN( risfdep(:,:) , gdept_0(:,:,jk) )            &
+!                               + MAX(   0._wp    , gdept_0(:,:,jk)-risfdep(:,:) ) * ( 1._wp + r3t(:,:,Kmm) )
+!             gdepw(:,:,jk,Kmm) = MIN( risfdep(:,:) , gdepw_0(:,:,jk) )    &
+!                               + MAX(   0._wp    , gdepw_0(:,:,jk)-risfdep(:,:) ) * ( 1._wp + r3t(:,:,Kmm) )
+!             gde3w(:,:,jk)     = gdept(:,:,jk,Kmm) - ssh(:,:,Kmm)
+!             gdept(:,:,jk,Kbb) = MIN( risfdep(:,:) , gdept_0(:,:,jk) )            &
+!                               + MAX(   0._wp    , gdept_0(:,:,jk)-risfdep(:,:) ) * ( 1._wp + r3t(:,:,Kbb) )
+!             gdepw(:,:,jk,Kbb) = MIN( risfdep(:,:) , gdepw_0(:,:,jk) )    &
+!                               + MAX(   0._wp    , gdepw_0(:,:,jk)-risfdep(:,:) ) * ( 1._wp + r3t(:,:,Kbb) )
+!          END DO
+!          !
+!       ELSE                       !** No cavities   (all depth rescaled, even inside topography: no mask)
+!          !
+! !!gm idea 0 :   just realize that mask is not needed ===>>>> without ISF, rescale all grid point position : no mask !
+!          DO jk = 1, jpk
+!             gdept(:,:,jk,Kmm) = gdept_0(:,:,jk) * ( 1._wp + r3t(:,:,Kmm) )
+!             gdepw(:,:,jk,Kmm) = gdepw_0(:,:,jk) * ( 1._wp + r3t(:,:,Kmm) )
+!             gde3w(:,:,jk)     = gdept  (:,:,jk,Kmm)       - ssh(:,:,Kmm)
+!             gdept(:,:,jk,Kbb) = gdept_0(:,:,jk) * ( 1._wp + r3t(:,:,Kbb) )
+!             gdepw(:,:,jk,Kbb) = gdepw_0(:,:,jk) * ( 1._wp + r3t(:,:,Kbb) )
+!          END DO
+!          !
+!       ENDIF
+!
+!       ! Local depth and Inverse of the local depth of the water
+!       ! -------------------------------------------------------
+!       !
+!       ht(:,:) = ht_0(:,:) + ssh(:,:,Kmm)
+!
+!       ! write restart file
+!       ! ==================
+!       IF( lrst_oce  )   CALL dom_qe_rst( kt, Kbb, Kmm, 'WRITE' )
+!       !
+!       IF( ln_timing )   CALL timing_stop('dom_qe_sf_update')
+!       !
+!    END SUBROUTINE dom_qe_sf_update
+!!st end
+
+   SUBROUTINE dom_h_update( kt, Kbb, Kmm, Kaa )
       !!----------------------------------------------------------------------
       !!                ***  ROUTINE dom_qe_sf_update  ***
@@ -346,8 +457,4 @@
       !!
       !! ** Action  :  - Recompute:
-      !!                    e3(u/v)_b
-      !!                    e3w(:,:,:,Kmm)
-      !!                    e3(u/v)w_b
-      !!                    e3(u/v)w_n
       !!                    gdept(:,:,:,Kmm), gdepw(:,:,:,Kmm)  and gde3w
       !!                    h(u/v) and h(u/v)r
@@ -377,21 +484,5 @@
       ! Horizontal scale factor interpolations
       ! --------------------------------------
-      ! - ML - e3u(:,:,:,Kbb) and e3v(:,:,:,Kbb) are already computed in dynnxt
       ! - JC - hu(:,:,:,Kbb), hv(:,:,:,:,Kbb), hur_b, hvr_b also
-
-
-      ! Scale factor computation
-      DO jk = 1, jpk             ! Horizontal interpolation
-         e3f(:,:,jk)      =  e3f_0(:,:,jk) * ( 1._wp + r3f(:,:) * fmask(:,:,jk) )   ! Kmm time level
-         !                       ! Vertical interpolation
-	      !                                   ! The ratio does not have to be masked at w-level
-         e3w (:,:,jk,Kmm) =  e3w_0(:,:,jk) * ( 1._wp + r3t(:,:,Kmm) )   ! Kmm time level
-         e3uw(:,:,jk,Kmm) = e3uw_0(:,:,jk) * ( 1._wp + r3u(:,:,Kmm) )
-         e3vw(:,:,jk,Kmm) = e3vw_0(:,:,jk) * ( 1._wp + r3v(:,:,Kmm) )
-         e3w (:,:,jk,Kbb) =  e3w_0(:,:,jk) * ( 1._wp + r3t(:,:,Kbb) )   ! Kbb time level
-         e3uw(:,:,jk,Kbb) = e3uw_0(:,:,jk) * ( 1._wp + r3u(:,:,Kbb) )
-         e3vw(:,:,jk,Kbb) = e3vw_0(:,:,jk) * ( 1._wp + r3v(:,:,Kbb) )
-      END DO
-
 
       IF( ln_isf ) THEN          !** IceShelF cavities
@@ -399,5 +490,5 @@
       !                             ! it should be something like that :  (with h_isf = thickness of iceshelf)
       !                             !  in fact currently, h_isf(:,:) is called : risfdep(:,:)
-!!gm - depth idea 0  : just realize that mask is not needed ===>>>> with ISF, rescale all grid point position below ISF : no mask !
+   !!gm - depth idea 0  : just realize that mask is not needed ===>>>> with ISF, rescale all grid point position below ISF : no mask !
          gdept(:,:,1,Kmm) = gdept_0(:,:,1) * ( 1._wp + r3t(:,:,Kmm) )
          gdepw(:,:,1,Kmm) = 0._wp                            ! Initialized to zero one for all
@@ -417,5 +508,5 @@
       ELSE                       !** No cavities   (all depth rescaled, even inside topography: no mask)
          !
-!!gm idea 0 :   just realize that mask is not needed ===>>>> without ISF, rescale all grid point position : no mask !
+   !!gm idea 0 :   just realize that mask is not needed ===>>>> without ISF, rescale all grid point position : no mask !
          DO jk = 1, jpk
             gdept(:,:,jk,Kmm) = gdept_0(:,:,jk) * ( 1._wp + r3t(:,:,Kmm) )
@@ -435,9 +526,7 @@
       ! write restart file
       ! ==================
-      IF( lrst_oce  )   CALL dom_qe_rst( kt, Kbb, Kmm, 'WRITE' )
-      !
       IF( ln_timing )   CALL timing_stop('dom_qe_sf_update')
       !
-   END SUBROUTINE dom_qe_sf_update
+   END SUBROUTINE dom_h_update
 
 
@@ -507,19 +596,16 @@
 
 
-   SUBROUTINE dom_qe_rst( kt, Kbb, Kmm, cdrw )
+   SUBROUTINE qe_rst_read( kt, Kbb, Kmm )
       !!---------------------------------------------------------------------
-      !!                   ***  ROUTINE dom_qe_rst  ***
-      !!
-      !! ** Purpose :   Read or write VVL file in restart file
+      !!                   ***  ROUTINE qe_rst_read  ***
+      !!
+      !! ** Purpose :   Read ssh in restart file
       !!
       !! ** Method  :   use of IOM library
-      !!                if the restart does not contain vertical scale factors,
-      !!                they are set to the _0 values
-      !!                if the restart does not contain vertical scale factors increments (z_tilde),
-      !!                they are set to 0.
+      !!                if the restart does not contain ssh,
+      !!                it is set to the _0 values.
       !!----------------------------------------------------------------------
       INTEGER         , INTENT(in) ::   kt        ! ocean time-step
       INTEGER         , INTENT(in) ::   Kbb, Kmm  ! ocean time level indices
-      CHARACTER(len=*), INTENT(in) ::   cdrw      ! "READ"/"WRITE" flag
       !
       INTEGER ::   ji, jj, jk
@@ -527,12 +613,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( TRIM(cdrw) == 'READ' ) THEN        ! Read/initialise
-         !                                   ! ===============
          IF( ln_rstart ) THEN                   !* Read the restart file
             CALL rst_read_open                  !  open the restart file if necessary
-            CALL iom_get( numror, jpdom_autoglo, 'sshn'   , ssh(:,:,Kmm), ldxios = lrxios    )
             !
-            id1 = iom_varid( numror, 'e3t_b', ldstop = .FALSE. )
-            id2 = iom_varid( numror, 'e3t_n', ldstop = .FALSE. )
+            id1 = iom_varid( numror, 'sshb', ldstop = .FALSE. )
+            id2 = iom_varid( numror, 'sshn', ldstop = .FALSE. )
             !
             !                             ! --------- !
